#! /usr/bin/perl

$gCGI_ZIP = "zipcode.cgi";
##########################################################################
&init;

  if($FORM{'action'} eq 'search_engine') { 
         &searchEngine; 
  }
  elsif($FORM{'action'} eq 'show_zip_code') { 
         &showZipCode; 
  }
  elsif($FORM{'action'} eq 'search_data') { 
         &searchData; 
  }
  else {
     &makeFrame;
  }

##########################################################################
sub searchData {

   my $query = $FORM{'query'};

print "Content-type: text/html\n\n";
print<<END;
<html>
<head>
<title>ZipCode Search Engine</title>
<link rel="stylesheet" type="text/css" href="./zipcode.css"> 
<SCRIPT language="JavaScript">
  function Copy(zip1, zip2, address) {
    top.opener.document.$FORM{form}.$FORM{zip1}.value = zip1;
    top.opener.document.$FORM{form}.$FORM{zip2}.value = zip2;
    top.opener.document.$FORM{form}.$FORM{address}.value = address;
    top.opener.document.$FORM{form}.$FORM{address}.focus();
    // close this window
    parent.window.close();
  }
</SCRIPT>
</head>
<body bgcolor=#efefef>

END

   sub zipcode_address {
     my %ZIPCODE;
     my $text = shift;
     return {'0', ''} if $text eq '';

     open HANDLE, "zipcode.db"  or return {'0', 'no zipcode DB file!'};
     while(<HANDLE>) {
       chomp;
       my ($z, $a) = split /\t/;
       (my $tmp = $a) =~ y/ //d;
       $ZIPCODE{$z} = $a if $tmp =~ /\Q$text/;
     }
     close HANDLE;
   
     \%ZIPCODE;
   }

   sub zipcode_code {

    my %ZIPCODE;
    my $code = shift;
    return {'0', ''} if $code eq '';
    $code =~ y/- //d;

    open HANDLE, "zipcode.db"  or return {'0', 'no zipcode DB file!'};
    while(<HANDLE>) {
      chomp;
      my ($z, $a) = split /\t/;
      $ZIPCODE{$z} = $a if $z =~ /$code/;
    }
    close HANDLE;

    \%ZIPCODE;
    }

    if($FORM{searchmode} eq 'address') {
       $ref = &zipcode_address($query);
    } 
    elsif($FORM{searchmode} eq 'code') {
           $ref = &zipcode_code($query);
    }
    
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./zipcode.css\">\n";
	for(sort keys %$ref) {
		my ($zip1, $zip2) = $_ =~ /(...)(...)/;
    print "&nbsp;&nbsp;&nbsp; 
          <img src=dot.gif border=0> &nbsp;<a href=\"javascript: Copy('$zip1','$zip2','$$ref{$_}')\">$zip1-$zip2 $$ref{$_}</a><br>\n";
  }
}

##########################################################################
sub searchEngine {
       print "Content-type: text/html\n\n";
       print<<END;
<html>
<head>
<title>ZipCode Search Engine</title>
<link rel="stylesheet" type="text/css" href="./zipcode.css"> 
</head>

<body bgcolor=#224466 scroll=no onLoad=document.zipcodeForm.query.focus()>
<FORM action=$gCGI_ZIP method=post target=Down name=zipcodeForm>
<table width=100% height=36 border=0 cellspacing=0 cellpadding=0 bgcolor=#224466 bordercolorlight=#aaaaaa bordercolordark=#000000>
<tr>
<td align=center valign=middle>
<input type=hidden name=action value=search_data>
<input type=hidden name=form value=$FORM{form}>
<input type=hidden name=zip1 value=$FORM{zip1}>
<input type=hidden name=zip2 value=$FORM{zip2}>
<input type=hidden name=address value=$FORM{address}>
<select name=searchmode size=1 onChange=document.zipcodeForm.query.focus()>
 <option value=address>ּҷ ã
 <option value=code>ȣ ã
</select>
<input type=text name=query size=14 style=\"height=16pt\">
<input type=submit name=submit value='   ' style=\"height=16pt\">
</td></tr></table>
</FORM>
</body>
</html>

END

}

##########################################################################
sub showZipCode {
       print "Content-type: text/html\n\n";
       print<<END;
<html>
<head>
<link rel="stylesheet" type="text/css" href="./zipcode.css"> 
</head>
<body bgcolor=#efefef>
<br><br><br><center>
<font color=red><b>// ̸ ԷϽð ' ˻ ' .</b></font><br>
<font color=black>(:ֹ/ȭ/ݼ)</font>
</center>
</body>
</html>

END

}


##########################################################################
sub makeFrame {
       print "Content-type: text/html\n\n";
       print<<END;
<HTML>
<HEAD>
<TITLE>ZipCode Search Engine</TITLE>
<FRAMESET ROWS="40,*" BORDER=0 marginwidth=0 marginheight=0 leftmargin=0 topmargin=0>
 <FRAME SRC="$gCGI_ZIP?action=search_engine&form=$FORM{form}&zip1=$FORM{zip1}&zip2=$FORM{zip2}&address=$FORM{address}" NAME="Top" border=0 marginheight=3 marginwidth=0 topmargin=3 leftmargin=0 border=0>
 <FRAME SRC="$gCGI_ZIP?action=show_zip_code" NAME="Down" border=0 marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 border=0>
</FRAMESET>
</HEAD>
</HTML>

END

}


##########################################################################
sub init {
  if ($ENV{'REQUEST_METHOD'} eq "POST") { 
      read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'}); 
  } 
  else { 
      $buffer = $ENV{'QUERY_STRING'}; 
  }

  for(split '&', $buffer) { 
     my ($name, $value) = split '=';
     $name =~ tr/+/ /;  $name =~ s/%(..)/chr(hex($1))/ge;
     $value =~ tr/+/ /;  $value =~ s/%(..)/chr(hex($1))/ge;
     $FORM{$name} = $value;
  }
}

__END__
